<script setup lang="ts">
  import { Product } from '@shopware-pwa/types';
  import { getTranslatedProperty } from '@shopware-pwa/helpers-next';

  const props = withDefaults(
    defineProps<{
      product: Product;
      layout?: 'detail' | 'listing';
      showRegulationPrice?: boolean;
      showPercentSaved?: boolean;
    }>(),
    {
      layout: 'detail',
      showRegulationPrice: true,
      showPercentSaved: true,
    },
  );

  const product = computed(() => props.product);
  const { unitPrice, isListPrice, price, tierPrices, displayFrom } = useProductPrice(product);

  const percentage = computed(() => price.value?.listPrice?.percentage || 0);
  const isSale = computed(() => isListPrice && percentage.value > 0);

  const { getFormattedPrice } = usePrice();
</script>
<template>
  <div v-if="product">
    <template v-if="layout === 'detail'">
      <template v-if="tierPrices.length <= 1">
        <span :class="['text-[1.75rem] font-bold', { 'text-danger': isSale }]">
          {{ getFormattedPrice(unitPrice, true) }}
        </span>
        <template v-if="isSale">
          <span class="text-(information-subdued xs) line-through">
            {{ getFormattedPrice(price?.listPrice?.price, true) }}
          </span>
          <span class="text-(information-subdued xs)">
            {{ $t('product.price.saved', { percent: percentage }) }}
          </span>
        </template>
        <span v-if="price?.regulationPrice" class="text-(information-subdued xs) ml-1">
          {{ $t('previously') }} {{ getFormattedPrice(price.regulationPrice.price, true) }}
        </span>
      </template>
      <template v-else>
        <table class="mb-4 w-full table-auto">
          <thead>
            <tr class="bg-background-raised text-left text-base">
              <th class="px-4 py-2.5 font-normal">
                {{ $t('product.price.quantity') }}
              </th>
              <th class="px-4 py-2.5 font-normal">
                {{ $t('product.price.unitPrice') }}
              </th>
              <th v-if="product.calculatedPrice?.referencePrice" class="px-4 py-2.5 font-normal">
                {{ $t('product.price.basePrice') }}
              </th>
            </tr>
          </thead>
          <tbody>
            <tr
              v-for="(tierPrice, index) in tierPrices"
              :key="tierPrice.label"
              :class="index > 0 && 'border-(border t)'"
            >
              <td class="px-4 py-2.5">
                <span v-if="index < tierPrices.length - 1"> {{ $t('product.price.to') }}</span
                ><span v-else> {{ $t('product.price.from') }}</span>
                <span class="pl-1">{{ tierPrice.quantity }}</span>
              </td>
              <td class="flex flex-col px-4 py-2.5">
                <span class="font-bold">{{ getFormattedPrice(tierPrice.unitPrice, true) }}</span>
                <span v-if="product.calculatedPrices[index]?.regulationPrice" class="text-xs"
                  >{{ $t('product.price.previously') }}
                  {{
                    getFormattedPrice(product.calculatedPrices[index]?.regulationPrice?.price, true)
                  }}</span
                >
              </td>
              <td v-if="product.calculatedPrice?.referencePrice" class="px-4 py-2.5">
                <div class="text-xs">
                  {{
                    getFormattedPrice(product.calculatedPrices[index].referencePrice?.price, true)
                  }}
                  / {{ product.referenceUnit }} {{ getTranslatedProperty(product.unit, 'name') }}
                </div>
              </td>
            </tr>
          </tbody>
        </table>
      </template>
    </template>
    <template v-if="layout === 'listing'">
      <template v-if="!displayFrom">
        <div class="flex flex-col items-end">
          <span class="text-xs font-bold" :class="{ 'text-danger': isSale }">
            {{ getFormattedPrice(unitPrice, true) }}
          </span>
          <div v-if="isSale" class="text-[7px]/[1.1]">
            <span class="line-through">
              {{ getFormattedPrice(price?.listPrice?.price, true) }}
            </span>
            <span v-if="showPercentSaved" class="pl-1">
              {{ $t('product.price.saved', { percent: percentage }) }}
            </span>
          </div>
          <span
            v-if="price?.regulationPrice && showRegulationPrice"
            class="text-right text-[7px]/[1.1]"
          >
            {{ $t('previously') }} {{ getFormattedPrice(price.regulationPrice.price, true) }}
          </span>
        </div>
      </template>
      <template v-else>
        <span class="text-xs font-bold">
          {{ $t('product.price.from') }} {{ getFormattedPrice(unitPrice, true) }}
        </span>
      </template>
    </template>
    <div v-if="product.purchaseUnit" class="text-(xs information-subdued) pt-1">
      {{ $t('product.content') }}: {{ product.purchaseUnit }}
      {{ getTranslatedProperty(product.unit, 'name') }}
      <span v-if="price?.referencePrice">
        ({{ getFormattedPrice(price.referencePrice.price, true) }} /
        {{ price.referencePrice.referenceUnit }} {{ price.referencePrice.unitName }})
      </span>
    </div>
  </div>
</template>
